#include <QApplication>
#include <QDialog>
#include <QPushButton>
#include <QTextEdit>
#include <QVBoxLayout>

#include <Qt>// Steps to trigger a crash in 5.12.2:
// 1. Click the "Open dialog!" button
// 2. Move the Dialog to the second monitor
// 3. Close the Dialog with the "X" in the top right.
// 4. Click the "Open dialog!" button to re-open the dialog.
// 5. The dialog will not paint correctly.
// 6. Re-size the dialog and it will paint correctly.
// 7. Scroll in the text box.
// 8. Crash:
// ASSERT failure in QWidget::mapTo(const QWidget *parent, const QPoint &pos): "parent must be in parent hierarchy", file // qtbase-everywhere-src-5_12_2/src/widgets/kernel/qwidget.cpp, line 4245
// Aborted

int main(int argc, char **argv) {
  QApplication app(argc, argv);
  QPushButton *button = new QPushButton("Open dialog!");
  QDialog *dialog = new QDialog(button, Qt::WindowCloseButtonHint | Qt::Window |
                                            Qt::WindowStaysOnTopHint);
  QVBoxLayout *dialog_layout = new QVBoxLayout(dialog);
  QTextEdit *text = new QTextEdit(dialog);
  text->setText(
      "This is a bunch of text so that a scroll bar will appear if the window "
      "is really small\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n.");
  text->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
  dialog_layout->addWidget(text);
  QObject::connect(button, &QPushButton::clicked,
                   [dialog]() { dialog->show(); });
  dialog->resize(50, 50);
  button->show();
  return app.exec();
}
